Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Interface QGraphicsItemInterface

All Superinterfaces:
  QtJambiInterface

All Known Implementing Classes:
  QAbstractGraphicsShapeItem, QGraphicsEllipseItem, QGraphicsItem, QGraphicsItemGroup, QGraphicsLineItem, QGraphicsPathItem, QGraphicsPixmapItem, QGraphicsPolygonItem, QGraphicsRectItem, QGraphicsSimpleTextItem, QGraphicsSvgItem, QGraphicsTextItem

    public interface QGraphicsItemInterface

extends QtJambiInterface

The `QGraphicsItem` class is the base class for all graphical items in a `QGraphicsScene`.

It provides a light-weight foundation for writing your own custom items. This includes defining the item's geometry, collision detection, its painting implementation and item interaction through its event handlers. `QGraphicsItem` is part of The Graphics View Framework

For convenience, Qt provides a set of standard graphics items for the most common shapes. These are:

- `QGraphicsEllipseItem` provides an ellipse item
- `QGraphicsLineItem` provides a line item
- `QGraphicsPathItem` provides an arbitrary path item
- `QGraphicsPixmapItem` provides a pixmap item
- `QGraphicsPolygonItem` provides a polygon item
- `QGraphicsRectItem` provides a rectangular item
- `QGraphicsSimpleTextItem` provides a simple text label item
- `QGraphicsTextItem` provides an advanced text browser item

All of an item's geometric information is based on its local coordinate system. The item's position, `pos`, is the only function that does not operate in local coordinates, as it returns a position in parent coordinates. {The Graphics View Coordinate System} describes the coordinate system in detail.

You can set whether an item should be visible (i.e., drawn, and accepting events), by calling `setVisible`. Hiding an item will also hide its children. Similarly, you can enable or disable an item by calling `setEnabled`. If you disable an item, all its children will also be disabled. By default, items are both visible and enabled. To toggle whether an item is selected or not, first enable selection by setting the ItemIsSelectable flag, and then call `setSelected`. Normally, selection is toggled by the scene, as a result of user interaction.

To write your own graphics item, you first create a subclass of `QGraphicsItem`, and then start by implementing its two pure virtual public functions: `boundingRect`, which returns an estimate of the area painted by the item, and `paint`, which implements the actual painting. For example:

        class SimpleItem : public QGraphicsItem
        {
        public:
            QRectF boundingRect() const
            {
                qreal penWidth = 1;
                return QRectF(-10 - penWidth / 2, -10 - penWidth / 2,
                              20 + penWidth / 2, 20 + penWidth / 2);
            }

            void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
                       QWidget *widget)
            {
                painter->drawRoundRect(-10, -10, 20, 20);
            }
        };

The `boundingRect` function has many different purposes. `QGraphicsScene` bases its item index on `boundingRect`, and `QGraphicsView` uses it both for culling invisible items, and for determining the area that needs to be recomposed when drawing overlapping items. In addition, `QGraphicsItem`'s collision detection mechanisms use `boundingRect` to provide an efficient cut-off. The fine grained collision algorithm in `collidesWithItem` is based on calling `shape`, which returns an accurate outline of the item's shape as a `QPainterPath`.

`QGraphicsScene` expects all items `boundingRect` and `shape` to remain unchanged unless it is notified. If you want to change an item's geometry in any way, you must first call `prepareGeometryChange` to allow `QGraphicsScene` to update its bookkeeping.

Collision detection can be done in two ways:

1. Reimplement `shape` to return an accurate shape for your item, and rely on the default implementation of `collidesWithItem` to do shape-shape intersection. This can be rather expensive if the shapes are complex.
2. Reimplement `collidesWithItem` to provide your own custom item and shape collision algorithm.

The `contains` function can be called to determine whether the item contains a point or not. This function can also be reimplemented by the item. The default behavior of `contains` is based on calling `shape`.

Items can contain other items, and also be contained by other items. All items can have a parent item and a list of children. Unless the item has no parent, its position is in parent coordinates (i.e., the parent's local coordinates). Parent items propagate both their position and their transformation to all children.

`QGraphicsItem` supports affine transformations in addition to its base position, `pos`. To change the item's transformation, you can either pass a transformation matrix to `setTransform`, or call one of the convenience functions `rotate`, `scale`, `translate`, or `shear`. Item transformations accumulate from parent to child, so if both a parent and child item are rotated 90 degrees, the child's total transformation will be 180 degrees. Similarly, if the item's parent is scaled to 2x its original size, its children will also be twice as large. An item's transformation does not affect its own local geometry; all geometry functions (e.g., `contains`, `update`, and all the mapping functions) still operate in local coordinates. For convenience, `QGraphicsItem` provides the functions `sceneTransform`, which returns the item's total transformation matrix (including its position and all parents' positions and transformations), and `scenePos`, which returns its position in scene coordinates. To reset an item's matrix, call `resetTransform`.

The `paint` function is called by `QGraphicsView` to paint the item's contents. The item has no background or default fill of its own; whatever is behind the item will shine through all areas that are not explicitly painted in this function. You can call `update` to schedule a repaint, optionally passing the rectangle that needs a repaint. Depending on whether or not the item is visible in a view, the item may or may not be repainted; there is no equivalent to QWidget::repaint() in `QGraphicsItem`.

Items are painted by the view, starting with the parent items and then drawing children, in ascending stacking order. You can set an item's stacking order by calling `setZValue`, and test it by calling `zValue`, where items with low z-values are painted before items with high z-values. Stacking order applies to sibling items; parents are always drawn before their children.

`QGraphicsItem` receives events from `QGraphicsScene` through the virtual function `sceneEvent`. This function distributes the most common events to a set of convenience event handlers:

- `contextMenuEvent` handles context menu events
- `focusInEvent` and `focusOutEvent` handle focus in and out events
- `hoverEnterEvent`, `hoverMoveEvent`, and `hoverLeaveEvent` handles hover enter, move and leave events
- `inputMethodEvent` handles input events, for accessibility support
- `keyPressEvent` and `keyReleaseEvent` handle key press and release events
- `mousePressEvent`, `mouseMoveEvent`, `mouseReleaseEvent`, and `mouseDoubleClickEvent` handles mouse press, move, release, click and doubleclick events

You can filter events for any other item by installing event filters. This functionaly is separate from from Qt's regular event filters (see QObject::installEventFilter()), which only work on subclasses of `QObject`. After installing your item as an event filter for another item by calling `installSceneEventFilter`, the filtered events will be received by the virtual function `sceneEventFilter`. You can remove item event filters by calling `removeSceneEventFilter`.

Sometimes it's useful to register custom data with an item, be it a custom item, or a standard item. You can call `setData` on any item to store data in it using a key-value pair (the key being an integer, and the value is a `QVariant`). To get custom data from an item, call `data`. This functionality is completely untouched by Qt itself; it is provided for the user's convenience.

See Also:
  `QGraphicsScene`, `QGraphicsView`, The Graphics View Framework

Method Summary
`boolean` | `acceptDrops()` Returns true if this item can accept drag and drop events; otherwise, returns false.
`Qt.MouseButtons` | `acceptedMouseButtons()` Returns the mouse buttons that this item accepts mouse events for.
`boolean` | `acceptsHoverEvents()` Returns true if an item accepts hover events (`QGraphicsSceneHoverEvent`); otherwise, returns false.
`void` | `addToIndex()`
`void` | `advance(int phase)` This virtual function is called twice for all items by the QGraphicsScene::advance() slot.
`QRectF` | `boundingRect()` This pure virtual function defines the outer bounds of the item as a rectangle; all painting must be restricted to inside an item's bounding rect.
`java.util.List<QGraphicsItemInterface>` | `childItems()` Returns a list of this item's children.
`QRectF` | `childrenBoundingRect()` Returns the bounding rect of this item's descendents (i.e., its children, their children, etc.) in local coordinates.
`void` | `clearFocus()` Takes keyboard input focus from the item.
`boolean` | `collidesWithItem(QGraphicsItemInterface other, Qt.ItemSelectionMode mode)` Returns true if this item collides with `other`; otherwise returns false.
`boolean` | `collidesWithPath(QPainterPath path, Qt.ItemSelectionMode mode)` Returns true if this item collides with `path`.
`java.util.List<QGraphicsItemInterface>` | `collidingItems(Qt.ItemSelectionMode mode)` Returns a list of all items that collide with this item.
`boolean` | `contains(QPointF point)` Returns true if this item contains `point`, which is in local coordinates; otherwise, false is returned.
`void` | `contextMenuEvent(QGraphicsSceneContextMenuEvent event)` This event handler can be reimplemented in a subclass to process context menu events.
`QCursor` | `cursor()` Returns the current cursor shape for the item.
`java.lang.Object` | `data(int key)` Returns this item's custom data for the key `key` as a `QVariant`.
`QTransform` | `deviceTransform(QTransform viewportTransform)` Returns this item's device transformation matrix, using `viewportTransform` to map from scene to device coordinates.
`void` | `dragEnterEvent(QGraphicsSceneDragDropEvent event)` This event handler, for event `event`, can be reimplemented to receive drag enter events for this item.
`void` | `dragLeaveEvent(QGraphicsSceneDragDropEvent event)` This event handler, for event `event`, can be reimplemented to receive drag leave events for this item.
`void` | `dragMoveEvent(QGraphicsSceneDragDropEvent event)` This event handler, for event `event`, can be reimplemented to receive drag move events for this item.
`void` | `dropEvent(QGraphicsSceneDragDropEvent event)` This event handler, for event `event`, can be reimplemented to receive drop events for this item.
`void` | `ensureVisible(double x, double y, double w, double h, int xmargin, int ymargin)` This convenience function is equivalent to calling `ensureVisible`(`QRectF`(`x`, `y`, `w`, `h`), `xmargin`, `ymargin`):
`void` | `ensureVisible(QRectF rect, int xmargin, int ymargin)` If this item is part of a scene that is viewed by a `QGraphicsView`, this convenience function will attempt to scroll the view to ensure that `rect` is visible inside the view's viewport.
`java.lang.Object` | `extension(java.lang.Object variant)`
`QGraphicsItem.GraphicsItemFlags` | `flags()` Returns this item's flags.
`void` | `focusInEvent(QFocusEvent event)` This event handler, for event `event`, can be reimplemented to receive focus in events for this item.
`void` | `focusOutEvent(QFocusEvent event)` This event handler, for event `event`, can be reimplemented to receive focus out events for this item.
`QGraphicsItemGroup` | `group()` Returns a pointer to this item's item group, or 0 if this item is not member of a group.
`boolean` | `handlesChildEvents()` Returns true if this item handles child events (i.e., all events intended for any of its children are instead sent to this item); otherwise, false is returned.
`boolean` | `hasCursor()` Returns true if this item has a cursor set; otherwise, false is returned.
`boolean` | `hasFocus()` Returns true if this item has focus (i.e., can accept key events); otherwise, returns false.
`void` | `hide()` Hides the item.
`void` | `hoverEnterEvent(QGraphicsSceneHoverEvent event)` This event handler, for event `event`, can be reimplemented to receive hover enter events for this item.
`void` | `hoverLeaveEvent(QGraphicsSceneHoverEvent event)` This event handler, for event `event`, can be reimplemented to receive hover leave events for this item.
`void` | `hoverMoveEvent(QGraphicsSceneHoverEvent event)` This event handler, for event `event`, can be reimplemented to receive hover move events for this item.
`void` | `inputMethodEvent(QInputMethodEvent event)` This event handler, for event `event`, can be reimplemented to receive input method events for this item.
`java.lang.Object` | `inputMethodQuery(Qt.InputMethodQuery query)` This method is only relevant for input items.
`void` | `installSceneEventFilter(QGraphicsItemInterface filterItem)` Installs an event filter for this item on `filterItem`, causing all events for this item to first pass through `filterItem`'s `sceneEventFilter` function.
`boolean` | `isAncestorOf(QGraphicsItemInterface child)` Returns true if this item is an ancestor of `child` (i.e., if this item is `child`'s parent, or one of `child`'s parent's ancestors).
`boolean` | `isEnabled()` Returns true if the item is enabled; otherwise, false is returned.
`boolean` | `isObscured()` Returns true if this item's bounding rect is completely obscured by the opaque shape of any of colliding items above it (i.e., with a higher Z value than this item).
`boolean` | `isObscured(double x, double y, double w, double h)` This convenience function is equivalent to calling `isObscured`(`QRectF`(`x`, `y`, `w`, `h`)).
`boolean` | `isObscured(QRectF rect)` Returns true if `rect` is completely obscured by the opaque shape of any of colliding items above it (i.e., with a higher Z value than this item).
`boolean` | `isObscuredBy(QGraphicsItemInterface item)` Returns true if this item's bounding rect is completely obscured by the opaque shape of `item`.
`boolean` | `isSelected()` Returns true if this item is selected; otherwise, false is returned.
`boolean` | `isVisible()` Returns true if the item is visible; otherwise, false is returned.
`java.lang.Object` | `itemChange(QGraphicsItem.GraphicsItemChange change, java.lang.Object value)` This virtual function is called by `QGraphicsItem` to notify custom items that some part of the item's state changes.
`void` | `keyPressEvent(QKeyEvent event)` This event handler, for event `event`, can be reimplemented to receive key press events for this item.
`void` | `keyReleaseEvent(QKeyEvent event)` This event handler, for event `event`, can be reimplemented to receive key release events for this item.
`QPointF` | `mapFromItem(QGraphicsItemInterface item, double x, double y)` This convenience function is equivalent to calling `mapFromItem`(`item`, `QPointF`(`x`, `y`)).
`QPolygonF` | `mapFromItem(QGraphicsItemInterface item, double x, double y, double w, double h)` This convenience function is equivalent to calling `mapFromItem`(item, `QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapFromItem(QGraphicsItemInterface item, QPainterPath path)` Maps the path `path`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped path.
`QPointF` | `mapFromItem(QGraphicsItemInterface item, QPointF point)` Maps the point `point`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapFromItem(QGraphicsItemInterface item, QPolygonF polygon)` Maps the polygon `polygon`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapFromItem(QGraphicsItemInterface item, QRectF rect)` Maps the rectangle `rect`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.
`QPointF` | `mapFromParent(double x, double y)` This convenience function is equivalent to calling `mapFromParent`(`QPointF`(`x`, `y`)).
`QPolygonF` | `mapFromParent(double x, double y, double w, double h)` This convenience function is equivalent to calling `mapFromItem`(`QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapFromParent(QPainterPath path)` Maps the path `path`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped path.
`QPointF` | `mapFromParent(QPointF point)` Maps the point `point`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapFromParent(QPolygonF polygon)` Maps the polygon `polygon`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapFromParent(QRectF rect)` Maps the rectangle `rect`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.
`QPointF` | `mapFromScene(double x, double y)` This convenience function is equivalent to calling `mapFromScene`(`QPointF`(`x`, `y`)).
`QPolygonF` | `mapFromScene(double x, double y, double w, double h)` This convenience function is equivalent to calling `mapFromScene`(`QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapFromScene(QPainterPath path)` Maps the path `path`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped path.
`QPointF` | `mapFromScene(QPointF point)` Maps the point `point`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapFromScene(QPolygonF polygon)` Maps the polygon `polygon`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapFromScene(QRectF rect)` Maps the rectangle `rect`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.
`QPointF` | `mapToItem(QGraphicsItemInterface item, double x, double y)` This convenience function is equivalent to calling `mapToItem`(`item`, `QPointF`(`x`, `y`)).
`QPolygonF` | `mapToItem(QGraphicsItemInterface item, double x, double y, double w, double h)` This convenience function is equivalent to calling `mapToItem`(item, `QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapToItem(QGraphicsItemInterface item, QPainterPath path)` Maps the path `path`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped path.
`QPointF` | `mapToItem(QGraphicsItemInterface item, QPointF point)` Maps the point `point`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapToItem(QGraphicsItemInterface item, QPolygonF polygon)` Maps the polygon `polygon`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapToItem(QGraphicsItemInterface item, QRectF rect)` Maps the rectangle `rect`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped rectangle as a polygon.
`QPointF` | `mapToParent(double x, double y)` This convenience function is equivalent to calling `mapToParent`(`QPointF`(`x`, `y`)).
`QPolygonF` | `mapToParent(double x, double y, double w, double h)` This convenience function is equivalent to calling `mapToParent`(`QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapToParent(QPainterPath path)` Maps the path `path`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped path.
`QPointF` | `mapToParent(QPointF point)` Maps the point `point`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapToParent(QPolygonF polygon)` Maps the polygon `polygon`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapToParent(QRectF rect)` Maps the rectangle `rect`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped rectangle as a polygon.
`QPointF` | `mapToScene(double x, double y)` This convenience function is equivalent to calling `mapToScene`(`QPointF`(`x`, `y`)).
`QPolygonF` | `mapToScene(double x, double y, double w, double h)` This convenience function is equivalent to calling `mapToScene`(`QRectF`(`x`, `y`, `w`, `h`)).
`QPainterPath` | `mapToScene(QPainterPath path)` Maps the path `path`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped path.
`QPointF` | `mapToScene(QPointF point)` Maps the point `point`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped coordinate.
`QPolygonF` | `mapToScene(QPolygonF polygon)` Maps the polygon `polygon`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped polygon.
`QPolygonF` | `mapToScene(QRectF rect)` Maps the rectangle `rect`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped rectangle as a polygon.
`void` | `mouseDoubleClickEvent(QGraphicsSceneMouseEvent event)` This event handler, for event `event`, can be reimplemented to receive mouse doubleclick events for this item.
`void` | `mouseMoveEvent(QGraphicsSceneMouseEvent event)` This event handler, for event `event`, can be reimplemented to receive mouse move events for this item.
`void` | `mousePressEvent(QGraphicsSceneMouseEvent event)` This event handler, for event `event`, can be reimplemented to receive mouse press events for this item.
`void` | `mouseReleaseEvent(QGraphicsSceneMouseEvent event)` This event handler, for event `event`, can be reimplemented to receive mouse release events for this item.
`void` | `moveBy(double dx, double dy)` Moves the item by `dx` points horizontally, and `dy` point vertically.
`QPainterPath` | `opaqueArea()` This virtual function returns a shape representing the area where this item is opaque.
`void` | `paint(QPainter painter, QStyleOptionGraphicsItem option, QWidget widget)` This function, which is usually called by `QGraphicsView`, paints the contents of an item in local coordinates.
`QGraphicsItemInterface` | `parentItem()` Returns a pointer to this item's parent item.
`QPointF` | `pos()` Returns the position of the item in parent coordinates.
`void` | `prepareGeometryChange()` Prepares the item for a geometry change.
`void` | `removeFromIndex()`
`void` | `removeSceneEventFilter(QGraphicsItemInterface filterItem)` Removes an event filter on this item from `filterItem`.
`void` | `resetTransform()` Resets this item's transformation matrix to the identity matrix.
`void` | `rotate(double angle)` Rotates the current item transformation `angle` degrees clockwise around its origin.
`void` | `scale(double sx, double sy)` Scales the current item transformation by (`sx`, `sy`) around its origin.
`QGraphicsScene` | `scene()` Returns the current scene for the item, or 0 if the item is not stored in a scene.
`QRectF` | `sceneBoundingRect()` Returns the bounding rect of this item in scene coordinates, by combining `sceneTransform` with `boundingRect`.
`boolean` | `sceneEvent(QEvent event)` This virtual function receives events to this item.
`boolean` | `sceneEventFilter(QGraphicsItemInterface watched, QEvent event)` Filters events for the item `watched`.
`QPointF` | `scenePos()` Returns the item's position in scene coordinates.
`QTransform` | `sceneTransform()` Returns this item's scene transformation matrix.
`void` | `setAcceptDrops(boolean on)` If `on` is true, this item will accept drag and drop events; otherwise, it is transparent for drag and drop events.
`void` | `setAcceptedMouseButtons(Qt.MouseButtons buttons)` Sets the mouse `buttons` that this item accepts mouse events for.
`void` | `setAcceptsHoverEvents(boolean enabled)` If `enabled` is true, this item will accept hover events; otherwise, it will ignore them.
`void` | `setCursor(QCursor cursor)` Sets the current cursor shape for the item to `cursor`.
`void` | `setData(int key, java.lang.Object value)` Sets this item's custom data for the key `key` to `value`.
`void` | `setEnabled(boolean enabled)` If `enabled` is true, the item is enabled; otherwise, it is disabled.
`void` | `setExtension(QGraphicsItem.Extension extension, java.lang.Object variant)`
`void` | `setFlag(QGraphicsItem.GraphicsItemFlag flag, boolean enabled)` If `enabled` is true, the item flag `flag` is enabled; otherwise, it is disabled.
`void` | `setFlags(QGraphicsItem.GraphicsItemFlags flags)` Sets the item flags to `flags`.
`void` | `setFocus(Qt.FocusReason focusReason)` Gives keyboard input focus to this item.
`void` | `setGroup(QGraphicsItemGroup group)` Adds this item to the item group `group`.
`void` | `setHandlesChildEvents(boolean enabled)` If `enabled` is true, this item is set to handle all events for all its children (i.e., all events intented for any of its children are instead sent to this item); otherwise, if `enabled` is false, this item will only handle its own events.
`void` | `setParentItem(QGraphicsItemInterface parent)` Sets this item's parent item to `parent`.
`void` | `setPos(double x, double y)` This convenience function is equivalent to calling `setPos`(`QPointF`(`x`, `y`)).
`void` | `setPos(QPointF pos)` Sets the position of the item to `pos`, which is in parent coordinates.
`void` | `setSelected(boolean selected)` If `selected` is true and this item is selectable, this item is selected; otherwise, it is unselected.
`void` | `setToolTip(java.lang.String toolTip)` Sets the item's tool tip to `toolTip`.
`void` | `setTransform(QTransform matrix, boolean combine)` Sets the item's current transformation matrix to `matrix`.
`void` | `setVisible(boolean visible)` If `visible` is true, the item is made visible.
`void` | `setZValue(double z)` Sets the Z-value, or the elevation, of the item, to `z`.
`QPainterPath` | `shape()` Returns the shape of this item as a `QPainterPath` in local coordinates.
`void` | `shear(double sh, double sv)` Shears the current item transformation by (`sh`, `sv`).
`void` | `show()` Shows the item.
`boolean` | `supportsExtension(QGraphicsItem.Extension extension)`
`java.lang.String` | `toolTip()` Returns the item's tool tip, or an empty `QString` if no tool tip has been set.
`QGraphicsItemInterface` | `topLevelItem()` Returns this item's top-level item.
`QTransform` | `transform()` Returns this item's transformation matrix.
`void` | `translate(double dx, double dy)` Translates the current item transformation by (`dx`, `dy`).
`int` | `type()` Returns the type of an item as an int.
`void` | `unsetCursor()` Clears the cursor from this item.
`void` | `update(double x, double y, double width, double height)` This convenience function is equivalent to calling update(`QRectF`(`x`, `y`, `width`, `height`)).
`void` | `update(QRectF rect)` Schedules a redraw of the area covered by `rect` in this item.
`void` | `wheelEvent(QGraphicsSceneWheelEvent event)` This event handler, for event `event`, can be reimplemented to receive wheel events for this item.
`double` | `x()` This convenience function is equivalent to calling `pos`.`x`.
`double` | `y()` This convenience function is equivalent to calling `pos`.`y`.
`double` | `zValue()` Returns the Z-value, or the elevation, of the item.

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Method Detail

### acceptDrops

    boolean acceptDrops()

  Returns true if this item can accept drag and drop events; otherwise, returns false. By default, items do not accept drag and drop events; items are transparent to drag and drop.

  See Also:
    `setAcceptDrops`

### acceptedMouseButtons

    Qt.MouseButtons acceptedMouseButtons()

  Returns the mouse buttons that this item accepts mouse events for. By default, all mouse buttons are accepted.

  If an item accepts a mouse button, it will become the mouse grabber item when a mouse press event is delivered for that mouse button. However, if the item does not accept the button, `QGraphicsScene` will forward the mouse events to the first item beneath it that does.

  See Also:
    `setAcceptedMouseButtons`, `mousePressEvent`

### acceptsHoverEvents

    boolean acceptsHoverEvents()

  Returns true if an item accepts hover events (`QGraphicsSceneHoverEvent`); otherwise, returns false. By default, items do not accept hover events.

  See Also:
    `setAcceptsHoverEvents`, `setAcceptedMouseButtons`

### addToIndex

    void addToIndex()

### childItems

    java.util.List<QGraphicsItemInterface> childItems()

  Returns a list of this item's children. The items are returned in no particular order.

  See Also:
    `setParentItem`

### childrenBoundingRect

    QRectF childrenBoundingRect()

  Returns the bounding rect of this item's descendents (i.e., its children, their children, etc.) in local coordinates. If the item has no children, this function returns an empty `QRectF`.

  This does not include this item's own bounding rect; it only returns its descendents' accumulated bounding rect. If you need to include this item's bounding rect, you can add `boundingRect` to `childrenBoundingRect` using QRectF::operator|().

  This function is linear in complexity; it determines the size of the returned bounding rect by iterating through all descendents.

  See Also:
    `boundingRect`, `sceneBoundingRect`

### clearFocus

    void clearFocus()

  Takes keyboard input focus from the item.

  If it has focus, a focus out event is sent to this item to tell it that it is about to lose the focus.

  Only items that set the ItemIsFocusable flag can accept keyboard focus.

  See Also:
    `setFocus`

### collidingItems

    java.util.List<QGraphicsItemInterface> collidingItems(Qt.ItemSelectionMode mode)

  Returns a list of all items that collide with this item.

  The way collisions are detected is determined by `mode`. The default value for `mode` is Qt::IntersectsItemShape; All items whose shape intersects or is contained by this item's shape are returned.

  See Also:
    `QGraphicsScene::collidingItems`, `collidesWithItem`

### cursor

    QCursor cursor()

  Returns the current cursor shape for the item. The mouse cursor will assume this shape when it's over this item. See the list of predefined cursor objects for a range of useful shapes.

  An editor item might want to use an I-beam cursor:

          item->setCursor(Qt::IBeamCursor);

  If no cursor has been set, the parent's cursor is used.

  See Also:
    `setCursor`, `hasCursor`, `unsetCursor`, `QWidget::cursor`, `QApplication::overrideCursor`

### data

    java.lang.Object data(int key)

  Returns this item's custom data for the key `key` as a `QVariant`.

  Custom item data is useful for storing arbitrary properties in any item. Example:

          static const int ObjectName = 0;

          QGraphicsItem *item = scene.itemAt(100, 50);
          if (item->data(ObjectName).toString().isEmpty()) {
              if (qgraphicsitem_cast<ButtonItem *>(item))
                  item->setData(ObjectName, "Button");
          }

  Qt does not use this feature for storing data; it is provided solely for the convenience of the user.

  See Also:
    `setData`

### deviceTransform

    QTransform deviceTransform(QTransform viewportTransform)

  Returns this item's device transformation matrix, using `viewportTransform` to map from scene to device coordinates. This matrix can be used to map coordinates and geometrical shapes from this item's local coordinate system to the viewport's (or any device's) coordinate system. To map coordinates from the viewport, you must first invert the returned matrix.

  Example:

          QGraphicsRectItem rect;
          rect.setPos(100, 100);

          rect.deviceTransform(view->viewportTransform()).map(QPointF(0, 0));
          // returns the item's (0, 0) point in view's viewport coordinates

          rect.deviceTransform(view->viewportTransform()).inverted().map(QPointF(100, 100));
          // returns view's viewport's (100, 100) coordinate in item coordinates

  This function is the same as combining this item's scene transform with the view's viewport transform, but is also understands ItemIgnoresTransformations.

  See Also:
    `transform`, `setTransform`, `scenePos`, The Graphics View Coordinate System

### ensureVisible

    void ensureVisible(double x,
                       double y,
                       double w,
                       double h,
                       int xmargin,
                       int ymargin)

  This convenience function is equivalent to calling `ensureVisible`(`QRectF`(`x`, `y`, `w`, `h`), `xmargin`, `ymargin`):

### ensureVisible

    void ensureVisible(QRectF rect,
                       int xmargin,
                       int ymargin)

  If this item is part of a scene that is viewed by a `QGraphicsView`, this convenience function will attempt to scroll the view to ensure that `rect` is visible inside the view's viewport. If `rect` is a null rect (the default), `QGraphicsItem` will default to the item's bounding rect. `xmargin` and `ymargin` are the number of pixels the view should use for margins.

  If the specified rect cannot be reached, the contents are scrolled to the nearest valid position.

  If this item is not viewed by a `QGraphicsView`, this function does nothing.

  See Also:
    `QGraphicsView::ensureVisible`

### flags

    QGraphicsItem.GraphicsItemFlags flags()

  Returns this item's flags. The flags describe what configurable features of the item are enabled and not. For example, if the flags include ItemIsFocusable, the item can accept input focus.

  By default, no flags are enabled.

  See Also:
    `setFlags`, `setFlag`

### group

    QGraphicsItemGroup group()

  Returns a pointer to this item's item group, or 0 if this item is not member of a group.

  See Also:
    `setGroup`, `QGraphicsItemGroup`, `QGraphicsScene::createItemGroup`

### handlesChildEvents

    boolean handlesChildEvents()

  Returns true if this item handles child events (i.e., all events intended for any of its children are instead sent to this item); otherwise, false is returned.

  This property is useful for item groups; it allows one item to handle events on behalf of its children, as opposed to its children handling their events individually.

  The default is to return false; children handle their own events. The exception for this is if the item is a `QGraphicsItemGroup`, then it defaults to return true.

  See Also:
    `setHandlesChildEvents`

### hasCursor

    boolean hasCursor()

  Returns true if this item has a cursor set; otherwise, false is returned.

  By default, items don't have any cursor set. `cursor` will return a standard pointing arrow cursor.

  See Also:
    `unsetCursor`

### hasFocus

    boolean hasFocus()

  Returns true if this item has focus (i.e., can accept key events); otherwise, returns false.

  See Also:
    `setFocus`, `QGraphicsScene::setFocusItem`

### hide

    void hide()

  Hides the item. (Items are visible by default.)

  This convenience function is equivalent to calling `setVisible(false)`.

  See Also:
    `show`, `setVisible`

### installSceneEventFilter

    void installSceneEventFilter(QGraphicsItemInterface filterItem)

  Installs an event filter for this item on `filterItem`, causing all events for this item to first pass through `filterItem`'s `sceneEventFilter` function.

  To filter another item's events, install this item as an event filter for the other item. Example:

          QGraphicsScene scene;
          QGraphicsEllipseItem *ellipse = scene.addEllipse(QRectF(-10, -10, 20, 20));
          QGraphicsLineItem *line = scene.addLine(QLineF(-10, -10, 20, 20));

          line->installSceneEventFilter(ellipse);
          // line's events are filtered by ellipse's sceneEventFilter() function.

          ellipse->installSceneEventFilter(line);
          // ellipse's events are filtered by line's sceneEventFilter() function.

  An item can only filter events for other items in the same scene. Also, an item cannot filter its own events; instead, you can reimplement `sceneEvent` directly.

  See Also:
    `removeSceneEventFilter`, `sceneEventFilter`, `sceneEvent`

### isAncestorOf

    boolean isAncestorOf(QGraphicsItemInterface child)

  Returns true if this item is an ancestor of `child` (i.e., if this item is `child`'s parent, or one of `child`'s parent's ancestors).

  See Also:
    `parentItem`

### isEnabled

    boolean isEnabled()

  Returns true if the item is enabled; otherwise, false is returned.

  See Also:
    `setEnabled`

### isObscured

    boolean isObscured()

  Returns true if this item's bounding rect is completely obscured by the opaque shape of any of colliding items above it (i.e., with a higher Z value than this item).

  Its implementation is based on calling `isObscuredBy`, which you can reimplement to provide a custom obscurity algorithm.

  See Also:
    `opaqueArea`

### isObscured

    boolean isObscured(double x,
                       double y,
                       double w,
                       double h)

  This convenience function is equivalent to calling `isObscured`(`QRectF`(`x`, `y`, `w`, `h`)).

### isObscured

    boolean isObscured(QRectF rect)

  Returns true if `rect` is completely obscured by the opaque shape of any of colliding items above it (i.e., with a higher Z value than this item).

  Unlike the default `isObscured` function, this function does not call `isObscuredBy`.

  See Also:
    `opaqueArea`

### isSelected

    boolean isSelected()

  Returns true if this item is selected; otherwise, false is returned.

  Items that are in a group inherit the group's selected state.

  Items are not selected by default.

  See Also:
    `setSelected`, `QGraphicsScene::setSelectionArea`

### isVisible

    boolean isVisible()

  Returns true if the item is visible; otherwise, false is returned.

  Note that the item's general visibility is unrelated to whether or not it is actually being visualized by a `QGraphicsView`.

  See Also:
    `setVisible`

### mapFromItem

    QPolygonF mapFromItem(QGraphicsItemInterface item,
                          QPolygonF polygon)

  Maps the polygon `polygon`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped polygon.

  If `item` is 0, this function returns the same as `mapFromScene`.

  See Also:
    `mapToItem`, `mapFromParent`, `transform`, The Graphics View Coordinate System

### mapFromItem

    QPolygonF mapFromItem(QGraphicsItemInterface item,
                          QRectF rect)

  Maps the rectangle `rect`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.

  If `item` is 0, this function returns the same as `mapFromScene`

  See Also:
    `mapToItem`, `mapFromParent`, `transform`, The Graphics View Coordinate System

### mapFromItem

    QPointF mapFromItem(QGraphicsItemInterface item,
                        QPointF point)

  Maps the point `point`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped coordinate.

  If `item` is 0, this function returns the same as `mapFromScene`.

  See Also:
    `mapFromParent`, `mapFromScene`, `transform`, `mapToItem`, The Graphics View Coordinate System

### mapFromItem

    QPolygonF mapFromItem(QGraphicsItemInterface item,
                          double x,
                          double y,
                          double w,
                          double h)

  This convenience function is equivalent to calling `mapFromItem`(item, `QRectF`(`x`, `y`, `w`, `h`)).

### mapFromItem

    QPainterPath mapFromItem(QGraphicsItemInterface item,
                             QPainterPath path)

  Maps the path `path`, which is in `item`'s coordinate system, to this item's coordinate system, and returns the mapped path.

  If `item` is 0, this function returns the same as `mapFromScene`.

  See Also:
    `mapFromParent`, `mapFromScene`, `mapToItem`, The Graphics View Coordinate System

### mapFromItem

    QPointF mapFromItem(QGraphicsItemInterface item,
                        double x,
                        double y)

  This convenience function is equivalent to calling `mapFromItem`(`item`, `QPointF`(`x`, `y`)).

### mapFromParent

    QPolygonF mapFromParent(double x,
                            double y,
                            double w,
                            double h)

  This convenience function is equivalent to calling `mapFromItem`(`QRectF`(`x`, `y`, `w`, `h`)).

### mapFromParent

    QPolygonF mapFromParent(QRectF rect)

  Maps the rectangle `rect`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.

  See Also:
    `mapToParent`, `mapFromItem`, `transform`, The Graphics View Coordinate System

### mapFromParent

    QPainterPath mapFromParent(QPainterPath path)

  Maps the path `path`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped path.

  See Also:
    `mapFromScene`, `mapFromItem`, `mapToParent`, The Graphics View Coordinate System

### mapFromParent

    QPolygonF mapFromParent(QPolygonF polygon)

  Maps the polygon `polygon`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped polygon.

  See Also:
    `mapToParent`, `mapToItem`, `transform`, The Graphics View Coordinate System

### mapFromParent

    QPointF mapFromParent(double x,
                          double y)

  This convenience function is equivalent to calling `mapFromParent`(`QPointF`(`x`, `y`)).

### mapFromParent

    QPointF mapFromParent(QPointF point)

  Maps the point `point`, which is in this item's parent's coordinate system, to this item's coordinate system, and returns the mapped coordinate.

  See Also:
    `mapFromItem`, `mapFromScene`, `transform`, `mapToParent`, The Graphics View Coordinate System

### mapFromScene

    QPolygonF mapFromScene(QPolygonF polygon)

  Maps the polygon `polygon`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped polygon.

  See Also:
    `mapToScene`, `mapFromParent`, `transform`, The Graphics View Coordinate System

### mapFromScene

    QPolygonF mapFromScene(double x,
                           double y,
                           double w,
                           double h)

  This convenience function is equivalent to calling `mapFromScene`(`QRectF`(`x`, `y`, `w`, `h`)).

### mapFromScene

    QPolygonF mapFromScene(QRectF rect)

  Maps the rectangle `rect`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped rectangle as a polygon.

  See Also:
    `mapToScene`, `mapFromItem`, `transform`, The Graphics View Coordinate System

### mapFromScene

    QPointF mapFromScene(QPointF point)

  Maps the point `point`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped coordinate.

  See Also:
    `mapFromItem`, `mapFromParent`, `transform`, `mapToScene`, The Graphics View Coordinate System

### mapFromScene

    QPointF mapFromScene(double x,
                         double y)

  This convenience function is equivalent to calling `mapFromScene`(`QPointF`(`x`, `y`)).

### mapFromScene

    QPainterPath mapFromScene(QPainterPath path)

  Maps the path `path`, which is in this item's scene's coordinate system, to this item's coordinate system, and returns the mapped path.

  See Also:
    `mapFromParent`, `mapFromItem`, `mapToScene`, The Graphics View Coordinate System

### mapToItem

    QPointF mapToItem(QGraphicsItemInterface item,
                      QPointF point)

  Maps the point `point`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped coordinate.

  If `item` is 0, this function returns the same as `mapToScene`.

  See Also:
    `mapToParent`, `mapToScene`, `transform`, `mapFromItem`, The Graphics View Coordinate System

### mapToItem

    QPainterPath mapToItem(QGraphicsItemInterface item,
                           QPainterPath path)

  Maps the path `path`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped path.

  If `item` is 0, this function returns the same as `mapToScene`.

  See Also:
    `mapToParent`, `mapToScene`, `mapFromItem`, The Graphics View Coordinate System

### mapToItem

    QPointF mapToItem(QGraphicsItemInterface item,
                      double x,
                      double y)

  This convenience function is equivalent to calling `mapToItem`(`item`, `QPointF`(`x`, `y`)).

### mapToItem

    QPolygonF mapToItem(QGraphicsItemInterface item,
                        double x,
                        double y,
                        double w,
                        double h)

  This convenience function is equivalent to calling `mapToItem`(item, `QRectF`(`x`, `y`, `w`, `h`)).

### mapToItem

    QPolygonF mapToItem(QGraphicsItemInterface item,
                        QPolygonF polygon)

  Maps the polygon `polygon`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped polygon.

  If `item` is 0, this function returns the same as `mapToScene`.

  See Also:
    `mapToParent`, `mapToScene`, `mapFromItem`, The Graphics View Coordinate System

### mapToItem

    QPolygonF mapToItem(QGraphicsItemInterface item,
                        QRectF rect)

  Maps the rectangle `rect`, which is in this item's coordinate system, to `item`'s coordinate system, and returns the mapped rectangle as a polygon.

  If `item` is 0, this function returns the same as `mapToScene`.

  See Also:
    `mapToParent`, `mapToScene`, `mapFromItem`, The Graphics View Coordinate System

### mapToParent

    QPolygonF mapToParent(QRectF rect)

  Maps the rectangle `rect`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped rectangle as a polygon. If the item has no parent, `rect` will be mapped to the scene's coordinate system.

  See Also:
    `mapToScene`, `mapToItem`, `mapFromParent`, The Graphics View Coordinate System

### mapToParent

    QPointF mapToParent(double x,
                        double y)

  This convenience function is equivalent to calling `mapToParent`(`QPointF`(`x`, `y`)).

### mapToParent

    QPolygonF mapToParent(QPolygonF polygon)

  Maps the polygon `polygon`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped polygon. If the item has no parent, `polygon` will be mapped to the scene's coordinate system.

  See Also:
    `mapToScene`, `mapToItem`, `mapFromParent`, The Graphics View Coordinate System

### mapToParent

    QPainterPath mapToParent(QPainterPath path)

  Maps the path `path`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped path. If the item has no parent, `path` will be mapped to the scene's coordinate system.

  See Also:
    `mapToScene`, `mapToItem`, `mapFromParent`, The Graphics View Coordinate System

### mapToParent

    QPointF mapToParent(QPointF point)

  Maps the point `point`, which is in this item's coordinate system, to its parent's coordinate system, and returns the mapped coordinate. If the item has no parent, `point` will be mapped to the scene's coordinate system.

  See Also:
    `mapToItem`, `mapToScene`, `transform`, `mapFromParent`, The Graphics View Coordinate System

### mapToParent

    QPolygonF mapToParent(double x,
                          double y,
                          double w,
                          double h)

  This convenience function is equivalent to calling `mapToParent`(`QRectF`(`x`, `y`, `w`, `h`)).

### mapToScene

    QPointF mapToScene(double x,
                       double y)

  This convenience function is equivalent to calling `mapToScene`(`QPointF`(`x`, `y`)).

### mapToScene

    QPainterPath mapToScene(QPainterPath path)

  Maps the path `path`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped path.

  See Also:
    `mapToParent`, `mapToItem`, `mapFromScene`, The Graphics View Coordinate System

### mapToScene

    QPolygonF mapToScene(QPolygonF polygon)

  Maps the polygon `polygon`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped polygon.

  See Also:
    `mapToParent`, `mapToItem`, `mapFromScene`, The Graphics View Coordinate System

### mapToScene

    QPolygonF mapToScene(QRectF rect)

  Maps the rectangle `rect`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped rectangle as a polygon.

  See Also:
    `mapToParent`, `mapToItem`, `mapFromScene`, The Graphics View Coordinate System

### mapToScene

    QPointF mapToScene(QPointF point)

  Maps the point `point`, which is in this item's coordinate system, to the scene's coordinate system, and returns the mapped coordinate.

  See Also:
    `mapToItem`, `mapToParent`, `transform`, `mapFromScene`, The Graphics View Coordinate System

### mapToScene

    QPolygonF mapToScene(double x,
                         double y,
                         double w,
                         double h)

  This convenience function is equivalent to calling `mapToScene`(`QRectF`(`x`, `y`, `w`, `h`)).

### moveBy

    void moveBy(double dx,
                double dy)

  Moves the item by `dx` points horizontally, and `dy` point vertically. This function is equivalent to calling `setPos`(`pos` + `QPointF`(`dx`, `dy`)).

### parentItem

    QGraphicsItemInterface parentItem()

  Returns a pointer to this item's parent item. If this item does not have a parent, 0 is returned.

  See Also:
    `setParentItem`, `children`

### pos

    QPointF pos()

  Returns the position of the item in parent coordinates. If the item has no parent, its position is given in scene coordinates.

  The position of the item describes its origin (local coordinate (0, 0)) in parent coordinates; this function returns the same as `mapToParent`(0, 0).

  For convenience, you can also call `scenePos` to determine the item's position in scene coordinates, regardless of its parent.

  See Also:
    `x`, `y`, `setPos`, `matrix`, The Graphics View Coordinate System

### prepareGeometryChange

    void prepareGeometryChange()

  Prepares the item for a geometry change. Call this function before changing the bounding rect of an item to keep `QGraphicsScene`'s index up to date.

  `prepareGeometryChange` will call `update` if this is necessary.

  Example:

          void CircleItem::setRadius(qreal newRadius)
          {
              if (radius != newRadius) {
                  prepareGeometryChange();
                  radius = newRadius;
              }
          }

  See Also:
    `boundingRect`

### removeFromIndex

    void removeFromIndex()

### removeSceneEventFilter

    void removeSceneEventFilter(QGraphicsItemInterface filterItem)

  Removes an event filter on this item from `filterItem`.

  See Also:
    `installSceneEventFilter`

### resetTransform

    void resetTransform()

  Resets this item's transformation matrix to the identity matrix. This is equivalent to calling `setTransform(QTransform())`.

  See Also:
    `setTransform`, `transform`

### rotate

    void rotate(double angle)

  Rotates the current item transformation `angle` degrees clockwise around its origin. To translate around an arbitrary point (x, y), you need to combine translation and rotation with `setTransform`.

  Example:

          // Rotate an item 45 degrees around (0, 0).
          item->rotate(45);

          // Rotate an item 45 degrees around (x, y).
          item->setTransform(QTransform().translate(x, y).rotate(45).translate(-x, -y));

  See Also:
    `setTransform`, `transform`, `scale`, `shear`, `translate`

### scale

    void scale(double sx,
               double sy)

  Scales the current item transformation by (`sx`, `sy`) around its origin. To scale from an arbitrary point (x, y), you need to combine translation and scaling with `setTransform`.

  Example:

          // Scale an item by 3x2 from its origin
          item->scale(3, 2);

          // Scale an item by 3x2 from (x, y)
          item->setTransform(QTransform().translate(x, y).scale(3, 2).translate(-x, -y));

  See Also:
    `setTransform`, `transform`, `rotate`, `shear`, `translate`

### scene

    QGraphicsScene scene()

  Returns the current scene for the item, or 0 if the item is not stored in a scene.

  To add or move an item to a scene, call QGraphicsScene::addItem().

### sceneBoundingRect

    QRectF sceneBoundingRect()

  Returns the bounding rect of this item in scene coordinates, by combining `sceneTransform` with `boundingRect`.

  See Also:
    `boundingRect`, The Graphics View Coordinate System

### scenePos

    QPointF scenePos()

  Returns the item's position in scene coordinates. This is equivalent to calling `mapToScene(0, 0)`.

  See Also:
    `pos`, `sceneTransform`, The Graphics View Coordinate System

### sceneTransform

    QTransform sceneTransform()

  Returns this item's scene transformation matrix. This matrix can be used to map coordinates and geometrical shapes from this item's local coordinate system to the scene's coordinate system. To map coordinates from the scene, you must first invert the returned matrix.

  Example:

          QGraphicsRectItem rect;
          rect.setPos(100, 100);

          rect.sceneTransform().map(QPointF(0, 0));
          // returns QPointF(100, 100);

          rect.sceneTransform().inverted().map(QPointF(100, 100));
          // returns QPointF(0, 0);

  Unlike `transform`, which returns only an item's local transformation, this function includes the item's (and any parents') position.

  See Also:
    `transform`, `setTransform`, `scenePos`, The Graphics View Coordinate System

### setAcceptDrops

    void setAcceptDrops(boolean on)

  If `on` is true, this item will accept drag and drop events; otherwise, it is transparent for drag and drop events. By default, items do not accept drag and drop events.

  See Also:
    `acceptDrops`

### setAcceptedMouseButtons

    void setAcceptedMouseButtons(Qt.MouseButtons buttons)

  Sets the mouse `buttons` that this item accepts mouse events for.

  By default, all mouse buttons are accepted. If an item accepts a mouse button, it will become the mouse grabber item when a mouse press event is delivered for that button. However, if the item does not accept the mouse button, `QGraphicsScene` will forward the mouse events to the first item beneath it that does.

  To disable mouse events for an item (i.e., make it transparent for mouse events), call `setAcceptedMouseButtons`(0).

  See Also:
    `acceptedMouseButtons`, `mousePressEvent`

### setAcceptsHoverEvents

    void setAcceptsHoverEvents(boolean enabled)

  If `enabled` is true, this item will accept hover events; otherwise, it will ignore them. By default, items do not accept hover events.

  Hover events are delivered when there is no current mouse grabber item. They are sent when the mouse cursor enters an item, when it moves around inside the item, and when the cursor leaves an item. Hover events are commonly used to highlight an item when it's entered, and for tracking the mouse cursor as it hovers over the item (equivalent to QWidget::mouseTracking).

  Parent items receive hover enter events before their children, and leave events after their children. The parent does not receive a hover leave event if the cursor enters a child, though; the parent stays "hovered" until the cursor leaves its area, including its children's areas.

  If a parent item handles child events (`setHandlesChildEvents`), it will receive hover move, drag move, and drop events as the cursor passes through its children, but it does not receive hover enter and hover leave, nor drag enter and drag leave events on behalf of its children.

  See Also:
    `acceptsHoverEvents`, `hoverEnterEvent`, `hoverMoveEvent`, `hoverLeaveEvent`

### setCursor

    void setCursor(QCursor cursor)

  Sets the current cursor shape for the item to `cursor`. The mouse cursor will assume this shape when it's over this item. See the list of predefined cursor objects for a range of useful shapes.

  An editor item might want to use an I-beam cursor:

          item->setCursor(Qt::IBeamCursor);

  If no cursor has been set, the cursor of the item beneath is used.

  See Also:
    `cursor`, `hasCursor`, `unsetCursor`, `QWidget::cursor`, `QApplication::overrideCursor`

### setData

    void setData(int key,
                 java.lang.Object value)

  Sets this item's custom data for the key `key` to `value`.

  Custom item data is useful for storing arbitrary properties for any item. Qt does not use this feature for storing data; it is provided solely for the convenience of the user.

  See Also:
    `data`

### setEnabled

    void setEnabled(boolean enabled)

  If `enabled` is true, the item is enabled; otherwise, it is disabled.

  Disabled items are visible, but they do not receive any events, and cannot take focus nor be selected. Mouse events are discarded; they are not propagated unless the item is also invisible, or if it does not accept mouse events (see `acceptedMouseButtons`). A disabled item cannot become the mouse grabber, and as a result of this, an item loses the grab if it becomes disabled when grabbing the mouse, just like it loses focus if it had focus when it was disabled.

  Disabled items are traditionally drawn using grayed-out colors (see `QPalette::Disabled`).

  If you disable a parent item, all its children will also be disabled. If you enable a parent item, all children will be enabled, unless they have been explicitly disabled (i.e., if you call `setEnabled`(false) on a child, it will not be reenabled if its parent is disabled, and then enabled again).

  Items are enabled by default.

  See Also:
    `isEnabled`

### setFlag

    void setFlag(QGraphicsItem.GraphicsItemFlag flag,
                 boolean enabled)

  If `enabled` is true, the item flag `flag` is enabled; otherwise, it is disabled.

  See Also:
    `flags`, `setFlags`

### setFlags

    void setFlags(QGraphicsItem.GraphicsItemFlags flags)

  Sets the item flags to `flags`. All flags in `flags` are enabled; all flags not in `flags` are disabled.

  If the item had focus and `flags` does not enable ItemIsFocusable, the item loses focus as a result of calling this function. Similarly, if the item was selected, and `flags` does not enabled ItemIsSelectable, the item is automatically unselected.

  By default, no flags are enabled.

  See Also:
    `flags`, `setFlag`

### setFocus

    void setFocus(Qt.FocusReason focusReason)

  Gives keyboard input focus to this item. The `focusReason` argument will be passed into any focus event generated by this function; it is used to give an explanation of what caused the item to get focus.

  Only items that set the ItemIsFocusable flag can accept keyboard focus.

  If this item is not visible (i.e., `isVisible` returns false), not enabled, not associated with a scene, or if it already has input focus, this function will do nothing.

  As a result of calling this function, this item will receive a focus in event with `focusReason`. If another item already has focus, that item will first receive a focus out event indicating that it has lost input focus.

  See Also:
    `clearFocus`, `hasFocus`

### setGroup

    void setGroup(QGraphicsItemGroup group)

  Adds this item to the item group `group`. If `group` is 0, this item is removed from any current group and added as a child of the previous group's parent.

  See Also:
    `group`, `QGraphicsScene::createItemGroup`

### setHandlesChildEvents

    void setHandlesChildEvents(boolean enabled)

  If `enabled` is true, this item is set to handle all events for all its children (i.e., all events intented for any of its children are instead sent to this item); otherwise, if `enabled` is false, this item will only handle its own events. The default value is false.

  This property is useful for item groups; it allows one item to handle events on behalf of its children, as opposed to its children handling their events individually.

  If a child item accepts hover events, its parent will receive hover move events as the cursor passes through the child, but it does not receive hover enter and hover leave events on behalf of its child.

  See Also:
    `handlesChildEvents`

### setParentItem

    void setParentItem(QGraphicsItemInterface parent)

  Sets this item's parent item to `parent`. If this item already has a parent, it is first removed from the previous parent. If `parent` is 0, this item will become a top-level item.

  See Also:
    `parentItem`, `children`

### setPos

    void setPos(QPointF pos)

  Sets the position of the item to `pos`, which is in parent coordinates. For items with no parent, `pos` is in scene coordinates.

  The position of the item describes its origin (local coordinate (0, 0)) in parent coordinates.

  See Also:
    `pos`, `scenePos`, The Graphics View Coordinate System

### setPos

    void setPos(double x,
                double y)

  This convenience function is equivalent to calling `setPos`(`QPointF`(`x`, `y`)).

  See Also:
    `pos`

### setSelected

    void setSelected(boolean selected)

  If `selected` is true and this item is selectable, this item is selected; otherwise, it is unselected.

  If the item is in a group, the whole group's selected state is toggled by this function. If the group is selected, all items in the group are also selected, and if the group is not selected, no item in the group is selected.

  Only visible, enabled, selectable items can be selected. If `selected` is true and this item is either invisible or disabled or unselectable, this function does nothing.

  By default, items cannot be selected. To enable selection, set the ItemIsSelectable flag.

  This function is provided for convenience, allowing individual toggling of the selected state of an item. However, a more common way of selecting items is to call QGraphicsScene::setSelectionArea(), which will call this function for all visible, enabled, and selectable items within a specified area on the scene.

  See Also:
    `isSelected`, `QGraphicsScene::selectedItems`

### setToolTip

    void setToolTip(java.lang.String toolTip)

  Sets the item's tool tip to `toolTip`. If `toolTip` is empty, the item's tool tip is cleared.

  See Also:
    `toolTip`, `QToolTip`

### setTransform

    void setTransform(QTransform matrix,
                      boolean combine)

  Sets the item's current transformation matrix to `matrix`.

  If `combine` is true, then `matrix` is combined with the current matrix; otherwise, `matrix` replaces the current matrix. `combine` is false by default.

  To simplify interation with items using a transformed view, `QGraphicsItem` provides mapTo... and mapFrom... functions that can translate between items' and the scene's coordinates. For example, you can call `mapToScene` to map an item coordiate to a scene coordinate, or `mapFromScene` to map from scene coordinates to item coordinates.

  See Also:
    `transform`, `rotate`, `scale`, `shear`, `translate`, The Graphics View Coordinate System

### setVisible

    void setVisible(boolean visible)

  If `visible` is true, the item is made visible. Otherwise, the item is made invisible. Invisible items are not painted, nor do they receive any events. In particular, mouse events pass right through invisible items, and are delivered to any item that may be behind. Invisible items are also unselectable, they cannot take input focus, and are not detected by `QGraphicsScene`'s item location functions.

  If an item becomes invisible while grabbing the mouse, (i.e., while it is receiving mouse events,) it will automatically lose the mouse grab, and the grab is not regained by making the item visible again; it must receive a new mouse press to regain the mouse grab.

  Similarly, an invisible item cannot have focus, so if the item has focus when it becomes invisible, it will lose focus, and the focus is not regained by simply making the item visible again.

  If you hide a parent item, all its children will also be hidden. If you show a parent item, all children will be shown, unless they have been explicitly hidden (i.e., if you call `setVisible`(false) on a child, it will not be reshown even if its parent is hidden, and then shown again).

  Items are visible by default; it is unnecessary to call `setVisible` on a new item.

  See Also:
    `isVisible`, `show`, `hide`

### setZValue

    void setZValue(double z)

  Sets the Z-value, or the elevation, of the item, to `z`. The elevation decides the stacking order of sibling (neighboring) items. An item of high Z-value will be drawn on top of an item with a lower Z-value if they share the same parent item. In addition, children of an item will always be drawn on top of the parent, regardless of the child's Z-value. Sibling items that share the same Z-value will be drawn in an undefined order, although the order will stay the same for as long as the items live.

  Children of different parents are stacked according to the Z-value of each item's ancestor item which is an immediate child of the two items' closest common ancestor. For example, a robot item might define a torso item as the parent of a head item, two arm items, and two upper-leg items. The upper-leg items would each be parents of one lower-leg item, and each lower-leg item would be parents of one foot item. The stacking order of the feet is the same as the stacking order of each foot's ancestor that is an immediate child of the two feet's common ancestor (i.e., the torso item); so the feet are stacked in the same order as the upper-leg items, regardless of each foot's Z-value.

  The Z-value does not affect the item's size in any way.

  The default Z-value is 0.

  See Also:
    `zValue`

### shear

    void shear(double sh,
               double sv)

  Shears the current item transformation by (`sh`, `sv`).

  See Also:
    `setTransform`, `transform`, `rotate`, `scale`, `translate`

### show

    void show()

  Shows the item. (Items are visible by default.)

  This convenience function is equivalent to calling `setVisible(true)`.

  See Also:
    `hide`, `setVisible`

### toolTip

    java.lang.String toolTip()

  Returns the item's tool tip, or an empty `QString` if no tool tip has been set.

  See Also:
    `setToolTip`, `QToolTip`

### topLevelItem

    QGraphicsItemInterface topLevelItem()

  Returns this item's top-level item. The top-level item is the item's topmost ancestor item whose parent is 0. If an item has no parent, its own pointer is returned (i.e., a top-level item is its own top-level item).

  See Also:
    `parentItem`

### transform

    QTransform transform()

  Returns this item's transformation matrix. If no matrix has been set, the identity matrix is returned.

  See Also:
    `setTransform`, `sceneTransform`

### translate

    void translate(double dx,
                   double dy)

  Translates the current item transformation by (`dx`, `dy`).

  If all you want is to move an item, you should call `moveBy` or `setPos` instead; this function changes the item's translation, which is conceptually separate from its position.

  See Also:
    `setTransform`, `transform`, `rotate`, `scale`, `shear`

### unsetCursor

    void unsetCursor()

  Clears the cursor from this item.

  See Also:
    `hasCursor`, `setCursor`

### update

    void update(QRectF rect)

  Schedules a redraw of the area covered by `rect` in this item. You can call this function whenever your item needs to be redrawn, such as if it changes appearance or size.

  This function does not cause an immediate paint; instead it schedules a paint request that is processed by `QGraphicsView` after control reaches the event loop. The item will only be redrawn if it is visible in any associated view.

  As a side effect of the item being repainted, other items that overlap the area `rect` may also be repainted.

  If the item is invisible (i.e., `isVisible` returns false), this function does nothing.

  See Also:
    `paint`, `boundingRect`

### update

    void update(double x,
                double y,
                double width,
                double height)

  This convenience function is equivalent to calling update(`QRectF`(`x`, `y`, `width`, `height`)).

### x

    double x()

  This convenience function is equivalent to calling `pos`.`x`.

  See Also:
    `y`

### y

    double y()

  This convenience function is equivalent to calling `pos`.`y`.

  See Also:
    `x`

### zValue

    double zValue()

  Returns the Z-value, or the elevation, of the item. The Z-value decides the stacking order of sibling (neighboring) items.

  The default Z-value is 0.

  See Also:
    `setZValue`

### advance

    void advance(int phase)

  This virtual function is called twice for all items by the QGraphicsScene::advance() slot. In the first phase, all items are called with `phase` == 0, indicating that items on the scene are about to advance, and then all items are called with `phase` == 1. Reimplement this function to update your item if you need simple scene-controlled animation.

  The default implementation does nothing.

  For individual item animation, an alternative to this function is to either use `QGraphicsItemAnimation`, or to multiple-inherit from `QObject` and `QGraphicsItem`, and animate your item using QObject::startTimer() and QObject::timerEvent().

  See Also:
    `QGraphicsItemAnimation`, `QTimeLine`

### boundingRect

    QRectF boundingRect()

  This pure virtual function defines the outer bounds of the item as a rectangle; all painting must be restricted to inside an item's bounding rect. `QGraphicsView` uses this to determine whether the item requires redrawing.

  Although the item's shape can be arbitrary, the bounding rect is always rectangular, and it is unaffected by the items' transformation (`scale`, `rotate`, etc.).

  If you want to change the item's bounding rectangle, you must first call `prepareGeometryChange`. This notifies the scene of the imminent change, so that its can update its item geometry index; otherwise, the scene will be unaware of the item's new geometry, and the results are undefined (typically, rendering artifacts are left around in the view).

  Reimplement this function to let `QGraphicsView` determine what parts of the widget, if any, need to be redrawn.

  Note: For shapes that paint an outline / stroke, it is important to include half the pen width in the bounding rect. It is not necessary to compensate for antialiasing, though.

  Example:

          QRectF CircleItem::boundingRect() const
          {
              qreal penWidth = 1;
              return QRectF(-radius - penWidth / 2, -radius - penWidth / 2,
                            diameter + penWidth, diameter + penWidth);
          }

  See Also:
    `shape`, `contains`, The Graphics View Coordinate System, `prepareGeometryChange`

### collidesWithItem

    boolean collidesWithItem(QGraphicsItemInterface other,
                             Qt.ItemSelectionMode mode)

  Returns true if this item collides with `other`; otherwise returns false. The ways items collide is determined by `mode`. The default value for `mode` is Qt::IntersectsItemShape; `other` collides with this item if it either intersect or are contained by this item's shape.

  The default implementation is based on shape intersection, and it calls `shape` on both items. Because the complexity of arbitrary shape-shape intersection grows with an order of magnitude when the shapes are complex, this operation can be noticably time consuming. You have the option of reimplementing this function in a subclass of `QGraphicsItem` to provide a custom algorithm. This allows you to make use of natural constraints in the shapes of your own items, in order to improve the performance of the collision detection. For instance, two untransformed perfectly circular items' collision can be determined very efficiently by comparing their positions and radii.

  Keep in mind that when reimplementing this function and calling `shape` or `boundingRect` on `other`, the returned coordinates must be mapped to this item's coordinate system before any intersection can take place.

  See Also:
    `contains`, `shape`

### collidesWithPath

    boolean collidesWithPath(QPainterPath path,
                             Qt.ItemSelectionMode mode)

  Returns true if this item collides with `path`.

  The collision is determined by `mode`. The default value for `mode` is Qt::IntersectsItemShape; `path` collides with this item if it either intersects or is contained by this item's shape.

  See Also:
    `collidesWithItem`, `contains`, `shape`

### contains

    boolean contains(QPointF point)

  Returns true if this item contains `point`, which is in local coordinates; otherwise, false is returned. It is most often called from `QGraphicsView` to determine what item is under the cursor, and for that reason, the implementation of this function should be as light-weight as possible.

  By default, this function calls `shape`, but you can reimplement it in a subclass to provide a (perhaps more efficient) implementation.

  See Also:
    `shape`, `boundingRect`, `collidesWithPath`

### contextMenuEvent

    void contextMenuEvent(QGraphicsSceneContextMenuEvent event)

  This event handler can be reimplemented in a subclass to process context menu events. The `event` parameter contains details about the event to be handled.

  If you ignore the event, (i.e., by calling QEvent::ignore(),) `event` will propagate to any item beneath this item. If no items accept the event, it will be ignored by the scene, and propagate to the view.

  It's common to open a `QMenu` in response to receiving a context menu event. Example:

          void CustomItem::contextMenuEvent(QGraphicsSceneContextMenuEvent *event)
          {
              QMenu menu;
              QAction *removeAction = menu.addAction("Remove");
              QAction *markAction = menu.addAction("Mark");
              QAction *selectedAction = menu.exec(event->screenPos());
              // ...
          }

  The default implementation does nothing.

  See Also:
    `sceneEvent`

### dragEnterEvent

    void dragEnterEvent(QGraphicsSceneDragDropEvent event)

  This event handler, for event `event`, can be reimplemented to receive drag enter events for this item. Drag enter events are generated as the cursor enters the item's area.

  By accepting the event, (i.e., by calling QEvent::accept(),) the item will accept drop events, in addition to receiving drag move and drag leave. Otherwise, the event will be ignored and propagate to the item beneath. If the event is accepted, the item will receive a drag move event before control goes back to the event loop.

  A common implementation of `dragEnterEvent` accepts or ignores `event` depending on the associated mime data in `event`. Example:

          CustomItem::CustomItem()
          {
              setAcceptDrops(true);
              ...
          }

          void CustomItem::dragEnterEvent(QGraphicsSceneDragDropEvent *event)
          {
              event->setAccepted(event->mimeData()->hasFormat("text/plain"));
          }

  Items do not receive drag and drop events by default; to enable this feature, call `setAcceptDrops(true)`.

  The default implementation does nothing.

  See Also:
    `dropEvent`, `dragMoveEvent`, `dragLeaveEvent`

### dragLeaveEvent

    void dragLeaveEvent(QGraphicsSceneDragDropEvent event)

  This event handler, for event `event`, can be reimplemented to receive drag leave events for this item. Drag leave events are generated as the cursor leaves the item's area. Most often you will not need to reimplement this function, but it can be useful for resetting state in your item (e.g., highlighting).

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  Items do not receive drag and drop events by default; to enable this feature, call `setAcceptDrops(true)`.

  The default implementation does nothing.

  See Also:
    `dragEnterEvent`, `dropEvent`, `dragMoveEvent`

### dragMoveEvent

    void dragMoveEvent(QGraphicsSceneDragDropEvent event)

  This event handler, for event `event`, can be reimplemented to receive drag move events for this item. Drag move events are generated as the cursor moves around inside the item's area. Most often you will not need to reimplement this function; it is used to indicate that only parts of the item can accept drops.

  Calling QEvent::ignore() or QEvent::accept() on `event` toggles whether or not the item will accept drops at the position from the event. By default, `event` is accepted, indicating that the item allows drops at the specified position.

  Items do not receive drag and drop events by default; to enable this feature, call `setAcceptDrops(true)`.

  The default implementation does nothing.

  See Also:
    `dropEvent`, `dragEnterEvent`, `dragLeaveEvent`

### dropEvent

    void dropEvent(QGraphicsSceneDragDropEvent event)

  This event handler, for event `event`, can be reimplemented to receive drop events for this item. Items can only receive drop events if the last drag move event was accepted.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  Items do not receive drag and drop events by default; to enable this feature, call `setAcceptDrops(true)`.

  The default implementation does nothing.

  See Also:
    `dragEnterEvent`, `dragMoveEvent`, `dragLeaveEvent`

### extension

    java.lang.Object extension(java.lang.Object variant)

  See Also:
    `setExtension`

### focusInEvent

    void focusInEvent(QFocusEvent event)

  This event handler, for event `event`, can be reimplemented to receive focus in events for this item. The default implementation does nothing.

  See Also:
    `focusOutEvent`, `sceneEvent`

### focusOutEvent

    void focusOutEvent(QFocusEvent event)

  This event handler, for event `event`, can be reimplemented to receive focus out events for this item. The default implementation does nothing.

  See Also:
    `focusInEvent`, `sceneEvent`

### hoverEnterEvent

    void hoverEnterEvent(QGraphicsSceneHoverEvent event)

  This event handler, for event `event`, can be reimplemented to receive hover enter events for this item. The default implementation calls `update`; otherwise it does nothing.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  See Also:
    `hoverMoveEvent`, `hoverLeaveEvent`, `sceneEvent`, `setAcceptsHoverEvents`

### hoverLeaveEvent

    void hoverLeaveEvent(QGraphicsSceneHoverEvent event)

  This event handler, for event `event`, can be reimplemented to receive hover leave events for this item. The default implementation calls `update`; otherwise it does nothing.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  See Also:
    `hoverEnterEvent`, `hoverMoveEvent`, `sceneEvent`, `setAcceptsHoverEvents`

### hoverMoveEvent

    void hoverMoveEvent(QGraphicsSceneHoverEvent event)

  This event handler, for event `event`, can be reimplemented to receive hover move events for this item. The default implementation does nothing.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  See Also:
    `hoverEnterEvent`, `hoverLeaveEvent`, `sceneEvent`, `setAcceptsHoverEvents`

### inputMethodEvent

    void inputMethodEvent(QInputMethodEvent event)

  This event handler, for event `event`, can be reimplemented to receive input method events for this item. The default implementation ignores the event.

  See Also:
    `inputMethodQuery`, `sceneEvent`

### inputMethodQuery

    java.lang.Object inputMethodQuery(Qt.InputMethodQuery query)

  This method is only relevant for input items. It is used by the input method to query a set of properties of the item to be able to support complex input method operations, such as support for surrounding text and reconversions. `query` specifies which property is queried.

  See Also:
    `inputMethodEvent`

### isObscuredBy

    boolean isObscuredBy(QGraphicsItemInterface item)

  Returns true if this item's bounding rect is completely obscured by the opaque shape of `item`.

  The base implementation maps `item`'s `opaqueArea` to this item's coordinate system, and then checks if this item's `boundingRect` is fully contained within the mapped shape.

  You can reimplement this function to provide a custom algorithm for determining whether this item is obscured by `item`.

  See Also:
    `opaqueArea`, `isObscured`

### itemChange

    java.lang.Object itemChange(QGraphicsItem.GraphicsItemChange change,
                                java.lang.Object value)

  This virtual function is called by `QGraphicsItem` to notify custom items that some part of the item's state changes. By reimplementing this function, your can react to a change, and in some cases, (depending on `change`,) adjustments can be made.

  `change` is the parameter of the item that is changing. `value` is the new value; the type of the value depends on `change`.

  Example:

          QVariant Component::itemChange(GraphicsItemChange change, const QVariant &value)
          {
              if (change == ItemPositionChange && scene()) {
                  // value is the new position.
                  QPointF newPos = value.toPointF();
                  QRectF rect = scene()->sceneRect();
                  if (!rect.contains(newPos)) {
                      // Keep the item inside the scene rect.
                      newPos.setX(qMin(rect.right(), qMax(newPos.x(), rect.left())));
                      newPos.setY(qMin(rect.bottom(), qMax(newPos.y(), rect.top())));
                      return newPos;
                  }
              }
              return QGraphicsItem::itemChange(change, value);
          }

  The default implementation does nothing, and returns `value`.

  Note: Certain `QGraphicsItem` functions cannot be called in a reimplementation of this function; see the GraphicsItemChange documentation for details.

  See Also:
    `GraphicsItemChange`

### keyPressEvent

    void keyPressEvent(QKeyEvent event)

  This event handler, for event `event`, can be reimplemented to receive key press events for this item. The default implementation ignores the event. If you reimplement this handler, the event will by default be accepted.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  Note that key events are only received for items that set the ItemIsFocusable flag, and that have keyboard input focus.

  See Also:
    `keyReleaseEvent`, `setFocus`, `QGraphicsScene::setFocusItem`, `sceneEvent`

### keyReleaseEvent

    void keyReleaseEvent(QKeyEvent event)

  This event handler, for event `event`, can be reimplemented to receive key release events for this item. The default implementation ignores the event. If you reimplement this handler, the event will by default be accepted.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  Note that key events are only received for items that set the ItemIsFocusable flag, and that have keyboard input focus.

  See Also:
    `keyPressEvent`, `setFocus`, `QGraphicsScene::setFocusItem`, `sceneEvent`

### mouseDoubleClickEvent

    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent event)

  This event handler, for event `event`, can be reimplemented to receive mouse doubleclick events for this item.

  When doubleclicking an item, the item will first receive a mouse press event, followed by a release event (i.e., a click), then a doubleclick event, and finally a release event.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  The default implementation calls `mousePressEvent`. If you want to keep the base implementation when reimplementing this function, call QGraphicsItem::mouseDoubleClickEvent() in your reimplementation.

  See Also:
    `mousePressEvent`, `mouseMoveEvent`, `mouseReleaseEvent`, `sceneEvent`

### mouseMoveEvent

    void mouseMoveEvent(QGraphicsSceneMouseEvent event)

  This event handler, for event `event`, can be reimplemented to receive mouse move events for this item. If you do receive this event, you can be certain that this item also received a mouse press event, and that this item is the current mouse grabber.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  The default implementation handles basic item interaction, such as selection and moving. If you want to keep the base implementation when reimplementing this function, call QGraphicsItem::mouseMoveEvent() in your reimplementation.

  See Also:
    `mousePressEvent`, `mouseReleaseEvent`, `mouseDoubleClickEvent`, `sceneEvent`

### mousePressEvent

    void mousePressEvent(QGraphicsSceneMouseEvent event)

  This event handler, for event `event`, can be reimplemented to receive mouse press events for this item. Mouse press events are only delivered to items that accept the mouse button that is pressed. By default, an item accepts all mouse buttons, but you can change this by calling `setAcceptedMouseButtons`.

  The mouse press event decides which item should become the mouse grabber (see QGraphicsScene::mouseGrabberItem()). If you do not reimplement this function, the press event will propagate to any topmost item beneath this item, and no other mouse events will be delivered to this item.

  If you do reimplement this function, `event` will by default be accepted (see QEvent::accept()), and this item is then the mouse grabber. This allows the item to receive future move, release and doubleclick events. If you call QEvent::ignore() on `event`, this item will lose the mouse grab, and `event` will propagate to any topmost item beneath. No further mouse events will be delivered to this item unless a new mouse press event is received.

  The default implementation handles basic item interaction, such as selection and moving. If you want to keep the base implementation when reimplementing this function, call QGraphicsItem::mousePressEvent() in your reimplementation.

  See Also:
    `mouseMoveEvent`, `mouseReleaseEvent`, `mouseDoubleClickEvent`, `sceneEvent`

### mouseReleaseEvent

    void mouseReleaseEvent(QGraphicsSceneMouseEvent event)

  This event handler, for event `event`, can be reimplemented to receive mouse release events for this item.

  Calling QEvent::ignore() or QEvent::accept() on `event` has no effect.

  The default implementation handles basic item interaction, such as selection and moving. If you want to keep the base implementation when reimplementing this function, call QGraphicsItem::mouseReleaseEvent() in your reimplementation.

  See Also:
    `mousePressEvent`, `mouseMoveEvent`, `mouseDoubleClickEvent`, `sceneEvent`

### opaqueArea

    QPainterPath opaqueArea()

  This virtual function returns a shape representing the area where this item is opaque. An area is opaque if it is filled using an opaque brush or color (i.e., not transparent).

  This function is used by `isObscuredBy`, which is called by underlying items to determine if they are obscured by this item.

  The default implementation returns an empty `QPainterPath`, indicating that this item is completely transparent and does not obscure any other items.

  See Also:
    `isObscuredBy`, `isObscured`, `shape`

### paint

    void paint(QPainter painter,
               QStyleOptionGraphicsItem option,
               QWidget widget)

  This function, which is usually called by `QGraphicsView`, paints the contents of an item in local coordinates.

  Reimplement this function in a `QGraphicsItem` subclass to provide the item's painting implementation, using `painter`. The `option` parameter provides style options for the item, such as its state, exposed area and its level-of-detail hints. The `widget` argument is optional. If provided, it points to the widget that is being painted on; otherwise, it is 0.

          void RoundRectItem::paint(QPainter *painter,
                                    const QStyleOptionGraphicsItem *option,
                                    QWidget *widget)
          {
              painter->drawRoundRect(-10, -10, 20, 20);
          }

  The painter's pen is 0-width by default, and its pen is initialized to the QPalette::Text brush from the paint device's palette. The brush is initialized to QPalette::Window.

  All painting is done in local coordinates.

### sceneEvent

    boolean sceneEvent(QEvent event)

  This virtual function receives events to this item. Reimplement this function to intercept events before they are dispatched to the specialized event handlers `contextMenuEvent`, `focusInEvent`, `focusOutEvent`, `hoverEnterEvent`, `hoverMoveEvent`, `hoverLeaveEvent`, `keyPressEvent`, `keyReleaseEvent`, `mousePressEvent`, `mouseReleaseEvent`, `mouseMoveEvent`, and `mouseDoubleClickEvent`.

  Returns true if the event was recognized and handled; otherwise, (e.g., if the event type was not recognized,) false is returned.

  `event` is the intercepted event.

### sceneEventFilter

    boolean sceneEventFilter(QGraphicsItemInterface watched,
                             QEvent event)

  Filters events for the item `watched`. `event` is the filtered event.

  Reimplementing this function in a subclass makes it possible for the item to be used as an event filter for other items, intercepting all the events send to those items before they are able to respond.

  Reimplementations must return true to prevent further processing of a given event, ensuring that it will not be delivered to the watched item, or return false to indicate that the event should be propagated further by the event system.

  See Also:
    `installSceneEventFilter`

### setExtension

    void setExtension(QGraphicsItem.Extension extension,
                      java.lang.Object variant)

  See Also:
    `extension`

### shape

    QPainterPath shape()

  Returns the shape of this item as a `QPainterPath` in local coordinates. The shape is used for many things, including collision detection, hit tests, and for the QGraphicsScene::items() functions.

  The default implementation calls `boundingRect` to return a simple rectangular shape, but subclasses can reimplement this function to return a more accurate shape for non-rectangular items. For example, a round item may choose to return an elliptic shape for better collision detection. For example:

          QPainterPath RoundItem::shape() const
          {
              QPainterPath path;
              path.addEllipse(boundingRect());
              return path;
          }

  This function is called by the default implementations of `contains` and `collidesWithPath`.

  See Also:
    `boundingRect`, `contains`, `prepareGeometryChange`

### supportsExtension

    boolean supportsExtension(QGraphicsItem.Extension extension)

### type

    int type()

  Returns the type of an item as an int. All standard graphicsitem classes are associated with a unique value; see QGraphicsItem::Type. This type information is used by qgraphicsitem_cast() to distinguish between types.

  Reimplementing this function and declaring a Type enum value equal to your custom item's type will enable use of qgraphicsitem_cast() with the item. Custom items must return a value larger than or equal to UserType (65536).

  The default implementation (in `QGraphicsItem`) returns UserType.

### wheelEvent

    void wheelEvent(QGraphicsSceneWheelEvent event)

  This event handler, for event `event`, can be reimplemented to receive wheel events for this item. If you reimplement this function, `event` will be accepted by default.

  If you ignore the event, (i.e., by calling QEvent::ignore(),) it will propagate to any item beneath this item. If no items accept the event, it will be ignored by the scene, and propagate to the view (e.g., the view's vertical scroll bar).

  The default implementation ignores the event.

  See Also:
    `sceneEvent`

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD